package util;

import haxe.Exception;

/**
	JS-like promise class.
**/
class Promise<T> {
	private var thenCB:T->Void;
	private var errorCB:Exception->Void;

	public function then(cb:(data:T) -> Void):Promise<T> {
		thenCB = cb;

		return this;
	}

	public function error(cb:(err:Exception) -> Void) {
		errorCB = cb;
	}

	public function new(func:(resolve:(T) -> Void, reject:(Exception) -> Void)->Void) {
		try {
			func(data -> {
				if (thenCB != null) {
					thenCB(data);
				}
			}, e -> {
				if (errorCB != null) {
					errorCB(e);
				}
			});
		} catch (e:Exception) {
			if (errorCB != null) {
				errorCB(e);
			}
		}
	}
}
